#ifndef DTNINTERFACE_H
#define DTNINTERFACE_H

//#include <iostream.h>
#include <QtCore>
#include <QtNetwork>
#include <connection.h>
#include <dataPacket.h>
#include <neighbourAwareness.h>
#include <bundleManager.h>
#include <nodeManager.h>
#include <tcpClient.h>

/*! \brief This class handles the communication between PRoPHET and DTN.
 *
 * That is passing bundles between the BundleManager and DTN.<BR>
 * DTN States:<BR>
 * INIT - ???<BR>
 * DTNLIST - ???<BR>
 * IDLE - ???<BR>
 * PARSE - ???<BR>
 */
class DTNInterface : public QObject 
{

	Q_OBJECT
	public:
	int dtnState;
	int bundlesToParse;
	QList<Bundle> bundleList;
	QList<int> parsedList;
	DTNInterface(BundleManager*,NodeManager* nodeMng);
	BundleManager *bundleManager;
	NodeManager* nodeManager;
	int bundleIndex; 
	int hostPort;
	QHostAddress hostAddress;
	TcpClient *client;
	TcpClient *sender;
	QString ourName;
	int ourId;
	QTimer *timer;
	int ackOption;
		
	public slots:
	/*!
	 * Fetches bundles from DTN???
	 */
	void getBundles();
	
	void getResponse(QByteArray response);
	
	/*!
	 * Injects the specified bundle into DTN.
	 */
	void receiveBundle(Bundle);
	signals:
	
	/*!
	 * Emit the specified QString to the DTN-interface log.
	 */
	void sendLog(QString);
	
	/*!
	 * Emit the specified QString to the DTN-interface log.
	 */
	void sendBundle(Bundle);



};

#endif
