#ifndef INFOWIDGET_H
#define INFOWIDGET_H
#include <QtGui>
#include <QtNetwork>
#include <bundle.h>
#include <nodeManager.h>
#include <neighbourAwareness.h>

class InfoWidget : public QWidget
{

	Q_OBJECT

private:
		
	QLineEdit *label;

	
public:
	int seq;
	QComboBox *combo;
	QTextBrowser *readText;
	QFileDialog *file;
	QLineEdit *src;
	QLineEdit *dst;
	QLineEdit *opt;
	QTextEdit *line;
	QLineEdit *srcLine;
	QLineEdit *dstLine;
	InfoWidget(NodeManager*,QWidget *parent = 0);
	NodeManager* nodeManager;
	QTimer* timer;
	bool firstTime;
	QListWidget* msgList;
	QDir dir;
	//Status variables
	QProgressBar *memoryBar;
	QProgressBar *fileBar;
	QProgressBar *speedBar;
	QLabel *labelRed;
	QLabel *labelGreen;
	QLabel *labelYellow;
	QLineEdit *greenLine;
	QLineEdit *redLine;
	QLineEdit *yellowLine;
	int trafficSum;
	float trafficRate;
	QTimer *trafficTimer;
	QTimer *yellowTimer;
	QTimer *redTimer;
	QPixmap	*redOn;
	QPixmap	*redOff;
	QPixmap	*yellowOn;
	QPixmap	*yellowOff;
	QPixmap	*greenOn;
	QPixmap	*greenOff;
	bool yellow;
	QTableWidget* conTable;

	
	//Configuration variables
	int NODEID;
	QString NODENAME;
	QHostAddress NODEIP;
	QHostAddress NODEIP2;
	QHostAddress NODEBROADCAST;
	int BROADCAST;
	int AGINGTIMER;
	float PENCOUNTER;
	float BETA;
	float GAMMA;
	int HELLO;
	int ALIVE;
	int HELLOTIMER;
	int INITIATORTIMER;
	int LISTENERTIMER;
	QHostAddress DTNHOSTNAME;
	int DNTTIMER;
	int STORAGESIZE;
	int MEMORYSIZE;
	int ROUTING;
	int QUEUE;
	int CONTINIUSUPDATE;
	QString STORAGEPATH;
	QString LOGPATH;
	QString MSGPATH;
	int AGEFILENODES;
	int USEFILENODES;
	int WRITETOFILETIMER;
	int USEFILEBUNDLES;
	int LOGGING;


	QLineEdit * lineNODEID;
	QLineEdit * lineNODENAME;
	QLineEdit * lineNODEIP;
	QLineEdit * lineNODEIP2;
	QLineEdit * lineNODEBROADCAST;
	QLineEdit * lineBROADCAST;
	QLineEdit * lineAGINGTIMER;
	QLineEdit * linePENCOUNTER;
	QLineEdit * lineBETA;
	QLineEdit * lineGAMMA;
	QLineEdit * lineHELLO;
	QLineEdit * lineALIVE;
	QLineEdit * lineHELLOTIMER;
	QLineEdit * lineINITIATORTIMER;
	QLineEdit * lineLISTENERTIMER;
	QLineEdit * lineDTNHOSTNAME;
	QLineEdit * lineDNTTIMER;
	QLineEdit * lineSTORAGESIZE;
	QLineEdit * lineMEMORYSIZE;
	QLineEdit * lineROUTING;
	QLineEdit * lineQUEUE;
	QLineEdit * lineCONTINIUSUPDATE;
	QLineEdit * lineSTORAGEPATH;
	QLineEdit * lineLOGPATH;
	QLineEdit * lineMSGPATH;
	QLineEdit * lineAGEFILENODES;
	QLineEdit * lineUSEFILENODES;
	QLineEdit * lineWRITETOFILETIMER;
	QLineEdit * lineUSEFILEBUNDLES;
	QLineEdit * lineLOGGING;
	QLineEdit * lineUSETTL;
	QLineEdit * lineTTL;
	QLineEdit * lineACKS;




signals:
	void sendConnectionList(QList <ConnectionInfo>);

public slots:
	void loadConfiguration();
	void calculateTraffic();
	void yellowLedOff();	
	void redLedOff();

	void getTraffic(int);
	void getConnectionList(QList <ConnectionInfo>);
	void getNewConnection(int);
	void getNewConnectionStatus(int);
	void getRemovedConnection(int);
	void getUsedFileStorage(int);
	void getUsedMemoryStorage(int);


};

#endif


