#include <QtGui>
#include <msgWidget.h>
#include <readFile.h>



MsgWidget::MsgWidget(NodeManager* nodeMng,BundleManager* bundleMng,QWidget *parent)
        : QWidget(parent)
{
#ifndef PDAGUI
	setFixedSize(990, 660);
#endif //PDAGUI
	nodeManager = nodeMng;
	bundleManager = bundleMng;
	connect(nodeMng,SIGNAL(updatedNodeList(NodeManager*)),this,SLOT(updatedNodeList(NodeManager*)));

#ifndef PDAGUI
	//Send message group
	QGroupBox *sendBox = new QGroupBox("Send message");
#endif //PDAGUI
    //Source
    QLabel *labelSrc = new QLabel(this);
    labelSrc->setText("Select destination:");
	src = new QLineEdit();
	src->setMaxLength(3); 
	//Destination
	QLabel *labelDst = new QLabel(this);
    labelDst->setText("Send message:");
	combo = new QComboBox(this);
	//Message
	QLabel *labelMsg = new QLabel(this);
    labelMsg->setText("Type message here:");
	line = new QTextEdit();

#ifndef PDAGUI
	dst = new QLineEdit();
	dst->setMaxLength(3); 
	//Options
	QLabel *labelOpt = new QLabel(this);
    labelOpt->setText("Received messages:");
	opt = new QLineEdit();
	opt->setMaxLength(3); 
	//sourceString
	QLabel *srcStr = new QLabel(this);
    srcStr->setText("Content:");
	srcLine = new QLineEdit();
	//destinationString
	QLabel *dstStr = new QLabel(this);
   // dstStr->setText("DestinationString");
	dstLine = new QLineEdit();
#endif //PDAGUI
	//Send
	QPushButton *send= new QPushButton("Send", this);
	//File
	//QFileDialog *file = new QFileDialog(this);	
	//Final grid layout
    QGridLayout *sendGroup = new QGridLayout;
	sendGroup->addWidget(labelSrc, 0, 0);
    sendGroup->addWidget(combo, 1, 0);

	sendGroup->addWidget(labelDst, 0, 1);
    sendGroup->addWidget(send, 1, 1);
	sendGroup->addWidget(labelMsg, 2, 0);
	sendGroup->addWidget(line, 3, 0, 1, 2);

	//sendGroup->addWidget(dst, 1, 1);
	//sendGroup->addWidget(combo, 2, 1);

	//sendGroup->addWidget(labelDst, 0, 1);
	//sendGroup->addWidget(dstLine, 3, 1);

	//sendGroup->addWidget(labelOpt, 0, 2);
	//sendGroup->addWidget(opt, 1, 2);

	//sendGroup->addWidget(labelMsg, 4, 0);
 	//sendGroup->addWidget(line, 5, 0, 1, 3);
    //sendGroup->addWidget(send, 3, 2);
	 //   sendGroup->addWidget(file, 6, 2);
#ifdef PDAGUI
	setLayout(sendGroup);
#else
	sendBox->setFixedSize(450, 620);
	sendBox->setLayout(sendGroup);
#endif //PDAGUI
	///////////////////////////////////////////////////
#ifndef PDAGUI
	QGroupBox *readBox = new QGroupBox("Read message");
	readText = new QTextBrowser(this);
	msgList = new QListWidget;
	//Final grid layout
    QGridLayout *readGroup = new QGridLayout;
	readGroup->addWidget(labelOpt, 0, 0);
	readGroup->addWidget(msgList, 1, 0);
	readGroup->addWidget(srcStr, 2, 0);
	readGroup->addWidget(readText, 3, 0);
 	readBox->setFixedSize(450, 620);
	readBox->setLayout(readGroup);
	Bundle *msg = new Bundle; //is this used for anything???
	//Define final layout
	QVBoxLayout *layout = new QVBoxLayout;
	layout->setDirection(QBoxLayout::LeftToRight);
    layout->addWidget(sendBox);    
    layout->addWidget(readBox);    
    setLayout(layout);
	//Define connections
//	connect(line, SIGNAL(returnPressed ()(QString)),label,SLOT(setText(QString)));
#endif //PDAGUI
	//Prepare update timer
	timer = new QTimer();
#ifndef PDAGUI
	connect(timer, SIGNAL(timeout()), this, SLOT(updateLists()));
	connect(msgList, SIGNAL(itemClicked (QListWidgetItem *)), this, SLOT(showMsg(QListWidgetItem *)));
	connect(msgList, SIGNAL(itemDoubleClicked  (QListWidgetItem *)), this, SLOT(showMsg(QListWidgetItem *)));
#endif //PDAGUI
	connect(nodeManager, SIGNAL(updatedNodeList(NodeManager*)), this, SLOT(updatedNodeList(NodeManager* )));

	bool b = connect(send,SIGNAL(clicked(void)),this, SLOT(composeBundle(void)) );



	timer->start(5000);
	firstTime=0;
	ReadFile conf;
	ackOption=conf.getUseACKS();
	QString msgPath=conf.getMsgPath();
	dir.setPath(msgPath);
	//create the dir if it does not exist
	if(!dir.exists())
		dir.mkpath(dir.path());
	sourceId =conf.getNodeId();
	sourceStr = conf.getNodeName();

}

void MsgWidget::updatedNodeList(NodeManager* ptr)
{
	//First time we update combobox
	QList <Node> nodeList;
	nodeList = nodeManager->getNodeList();
	combo->clear();
	for (ushort i = 0; i < nodeList.size(); ++i) 
	{
			combo->insertItem(i,nodeList.at(i).nodeName);
	}
	firstTime=1;

}


void MsgWidget::getBundle(Bundle newBundle)
{
	label->setText(newBundle.getData());
}

void MsgWidget::updateLists()
{
	if(firstTime==0)
	{
		//First time we update combobox
		QList <Node> nodeList;
		nodeList = nodeManager->getNodeList();
		combo->clear();
		for (ushort i = 0; i < nodeList.size(); ++i) 
		{
			combo->insertItem(i,nodeList.at(i).nodeName);
		}
		firstTime=1;
	}
#ifndef PDAGUI
	QList<QString> list;
	list = dir.entryList();
	msgList->clear();
	for (ushort i = 0; i < list.size(); ++i) 
	{
		QListWidgetItem *newItem = new QListWidgetItem;
		newItem->setText(list.at(i));
		msgList->insertItem(i, newItem);
	}
#endif //PDAGUI
}

void MsgWidget::showMsg(QListWidgetItem * item)
{
	QString fileName;
	if(item!=NULL)
	{
	fileName = item->text();
	if(fileName.size()>2)
	{
	
	QFile file(dir.filePath(fileName));
	if(file.open(QIODevice::ReadOnly))
	{
		QByteArray data;
		data=file.readAll();
		readText->clear();
		readText->insertPlainText(data);
		file.close();
	}
	}
}}





void MsgWidget::composeBundle()
{
	Bundle newBundle;
	QString stringData;// = line->text();
	QByteArray data = line->toPlainText().toAscii();
	if(combo->count()>0)
	{

		int dstId=nodeManager->nodeList.at(combo->currentIndex()).nodeId;
		QString dstStr = combo->itemText(combo->currentIndex()); 
		int option;
		option=0x04;
		//If acking is enabled
		if(ackOption==1)
		{
			//We set the ACKOption bit and set the ACK bit 
			option=option|0x01;
		}
		newBundle.setContent(bundleManager->getSeq(),sourceId,dstId,data,option,sourceStr.toAscii(),dstStr.toAscii());
		emit sendBundle(newBundle);
		 QMessageBox::information(this, "PRoPHET notSoIM",
		"Message sent!\n");
	}

}


