#ifndef READFILE_H
#define READFILE_H

#include <QtCore>
#include <QtNetwork>

//QSettings could be used instead...

/*! \brief This class contains the parser for the configuration file 
 * prophet.ini.
 * 
 * */
class ReadFile: public QObject
{
	Q_OBJECT

	public:

	QFile configuration;

	ReadFile();
	float getGamma();
	float getBeta();
	float getPEncounter();
	int getNodeId();
	int getAgingTimer();
	int getHelloTimer();
	int getInitiatorTimer();
	int getListenerTimer();
	int getDTNHostPort();
	int getMemoryStorageSize();
	int getStorageSize();
	int getAlive();
	int getBroadcastTimer();
	int getHello();
	int getContiniusUpdate();
	int getRouting();
	int getUseFileNodes();
	int getWriteToFileTimer();
	int getAgeFileNodes();
	int getUseFileBundles();
	int getLogOption();
	int getUseACKS();
	int getTTL();
	int getUseTTL();
	int getDTNTimer();
	int getQueue();
	int getSmartOffer();
	int getUseFileHash();
	
	QString getStoragePath();
	QString getMsgPath();
	QString getLogPath();



	QString getNodeName();
	QHostAddress getNodeIp();
	QHostAddress getNodeIp2();
	QHostAddress getDTNHostName();
	QHostAddress getBroadcast();
};

#endif
