#include <QtCore>
#include <tlv.h>
#include <hello.h>
#include <messageFile.h>
#include <readFile.h>
#include <stdio.h>


//WARNING: SOME OF THE STRUCTURES HAS BEEN MODIFIED AND ARE NOT THE SAME AS IN DRAFT!
struct HelloHeader
{
	qint32 type;
	qint32 function;
	qint32 timer;
	qint32 nameLenght;
	qint32 nodeId;
	qint32 nodeType;
};

struct DictionaryHeader 
{
	qint32 type;
	qint32 flags;
	qint32 lenght;
	qint32 entryCount;
	qint32 reserved;
};

struct BundleListHeader 
{
	qint32 type;
	qint32 flags;
	qint32 lenght;
	qint32 entryCount;
	qint32 reserved;
};

struct BundleListItem 
{
	qint32 destinationId;
	qint32 BFlags;
	qint32 reserved;
	qint32 bundleId;
};

struct BundleDataHeader 
{
	qint32 sourceId;
	qint32 destinationId;
	qint32 bundleId;
	qint32 BFlags;
	qint32 reserved;
	qint32 dataLenght;	
	qint32 sourceStringLenght;
	qint32 destinationStringLenght;
	uint time;
};


struct DictionaryNodeHeader 
{
	qint32 stringId;
	qint32 lenght;
	qint32 reserved;
};

struct RIBNodeHeader 
{
	qint32 stringId;
	float probability;
	qint32 RIBFlag;
};

struct Header 
{
	qint32 type;

};



TLV::TLV(QObject *parent)
{
	ReadFile conf;
	fileOption=conf.getUseFileBundles();
	if(fileOption==1)
	{
		QString storagePath=conf.getStoragePath();
		dir.setPath(storagePath);
	}
}



void TLV::receiveDatagram(QByteArray datagram)
{
	Header* TLVType;
	TLVType= (Header*) datagram.constData();
	qint32 datagramIndex;
	//Read out TLV Type
	QByteArray temp;
	Hello newHello;
	QList<Node> receivedNodes;
	QList<Bundle> receivedBundles;
	QString name;
	struct DictionaryHeader *dictionaryHeader; //It is the same for RIB
	struct BundleListHeader *bundleHeader;
	struct HelloHeader *hello;
	qint32 entryCount;	
	qint32 lenght;
	switch(TLVType->type)
	{
		//Hello massage forming
		case 0x01:	//////log->addLog(0,(QString)"TLV receiving Hello datagram...");
					hello= (HelloHeader*) datagram.constData();
 					newHello.HFunction=(qint32)hello->function;
					newHello.timer =(qint32)hello->timer;
					newHello.senderId=(qint32)hello->nodeId;
					newHello.senderType =(qint32)hello->nodeType;
					lenght = (qint32)hello->nameLenght;
					datagram.remove(0,sizeof(HelloHeader));
					name=datagram.mid(0,lenght);
					newHello.setSenderName(name);
					emit sendHello(newHello);
		break;
		//RIB
		case 0xA1:	//////log->addLog(0,(QString)"TLV receiving RIB datagram...");
					dictionaryHeader = (DictionaryHeader*) datagram.constData();
					entryCount=dictionaryHeader->entryCount;
					datagram.remove(0,sizeof(DictionaryHeader));
					for (ushort i = 0; i < entryCount; ++i) 
					{
						//Resolving data from datagram
						struct RIBNodeHeader *nodeHeader = (RIBNodeHeader*) datagram.constData();
						qint32 stringId = (qint32)nodeHeader->stringId;
						qint32 flag = (qint32)nodeHeader->RIBFlag;
						float probability = (float)nodeHeader->probability;
						datagram.remove(0,sizeof(RIBNodeHeader));
						//Setting node variables
						Node tempNode;
						tempNode.setContent(stringId,probability,flag,"X");
						//Adding variables in the list
						receivedNodes.append(tempNode);
					}
					emit sendRIB(receivedNodes);
		break;
		//BUNDLE OFFER RECEIVED
		case 0xA2:	//////log->addLog(0,(QString)"TLV receiving Bundle offer datagram...");
					bundleHeader = (BundleListHeader*) datagram.constData();
					entryCount=(qint32)bundleHeader->entryCount;
					datagramIndex=sizeof(BundleListHeader);
					datagram.remove(0,datagramIndex);
					for (ushort i = 0; i < entryCount; ++i) 
					{
						//Resolving data from datagram
						struct BundleListItem *bundleItem;
						bundleItem = (BundleListItem*) datagram.constData();
						
						qint32 destId = (qint32)bundleItem->destinationId;
						qint32 bundId = (qint32)bundleItem->bundleId;
						qint32 BFlags = (qint32)bundleItem->BFlags;
						qint32 reserved = (qint32)bundleItem->reserved;
						datagram.remove(0,sizeof(BundleListItem));
						//Setting Bundle variables
						Bundle tempBundle;
						tempBundle.destinationId = destId;
						tempBundle.id = bundId;
						tempBundle.options = BFlags;
						//Adding variables in the list
						receivedBundles.append(tempBundle);
					}
					emit sendBundleOffer(receivedBundles);
		break;
		//BUNDLE REQUEST RECEIVED
		case 0xA3:	//////log->addLog(0,(QString)"TLV receiving Bundle Request datagram...");
					bundleHeader = (BundleListHeader*) datagram.constData();
					entryCount=bundleHeader->entryCount;
					datagramIndex=sizeof(BundleListHeader);
					datagram.remove(0,datagramIndex);
					for (ushort i = 0; i < entryCount; ++i) 
					{
						//Resolving data from datagram
						struct BundleListItem *bundleItem;
						bundleItem = (BundleListItem*) datagram.constData();
						
						qint32 destId = (qint32)bundleItem->destinationId;
						qint32 bundId = (qint32)bundleItem->bundleId;
						qint32 BFlags = (qint32)bundleItem->BFlags;
						qint32 reserved = (qint32)bundleItem->reserved;
						datagram.remove(0,sizeof(BundleListItem));
						//Setting Bundle variables
						Bundle tempBundle;
						tempBundle.destinationId = destId;
						tempBundle.id = bundId;
						tempBundle.options = BFlags;
						//Adding variables in the list
						receivedBundles.append(tempBundle);
					}
					emit sendBundleRequest(receivedBundles);
		break;
		//Dictionary
		case 0xA0:	//////log->addLog(0,(QString)"TLV receiving Dictionary datagram...");
					dictionaryHeader = (DictionaryHeader*) datagram.constData();
					entryCount=dictionaryHeader->entryCount;
					datagram.remove(0,sizeof(DictionaryHeader));
					for (ushort i = 0; i < entryCount; ++i) 
					{
						QString nodeName;
						//Resolving data from datagram
						struct DictionaryNodeHeader * nodeHeader = (DictionaryNodeHeader*) datagram.constData();
						qint32 stringId = (qint32)nodeHeader->stringId;
						qint32 lenght = (qint32)nodeHeader->lenght;
						datagram.remove(0,sizeof(DictionaryNodeHeader)); //Because stings terminator
						nodeName=datagram.mid(0,lenght);
						datagram.remove(0,lenght);
						//Setting node variables
						Node tempNode;
						tempNode.setContent(stringId,0.0,-1,nodeName);
						//Adding variables in the list
						receivedNodes.append(tempNode);
					}
					emit sendDictionary(receivedNodes);
		break;		
		//BUNDLE DATA RECEIVED
		case 0xA4:	//////log->addLog(0,(QString)"TLV receiving Bundle data datagram...");
					bundleHeader = (BundleListHeader*) datagram.constData();
					entryCount=bundleHeader->entryCount;
					datagramIndex=sizeof(BundleListHeader);
					datagram.remove(0,datagramIndex);
					for (ushort i = 0; i < entryCount; ++i) 
					{
						//Resolving data from datagram
						struct BundleDataHeader *bundleItem;
						bundleItem = (BundleDataHeader*) datagram.constData();
						
						qint32 destId = (qint32)bundleItem->destinationId;
						qint32 srcId = (qint32)bundleItem->sourceId;
						qint32 bundId = (qint32)bundleItem->bundleId;
						qint32 BFlags = (qint32)bundleItem->BFlags;
						qint32 reserved = (qint32)bundleItem->reserved;
						qint32 lenght = (qint32)bundleItem->dataLenght;
						qint32 srclenght = (qint32)bundleItem->sourceStringLenght;
						qint32 dstlenght = (qint32)bundleItem->destinationStringLenght;
						
						QDateTime time;
						time.setTime_t(bundleItem->time);
						datagram.remove(0,sizeof(BundleDataHeader));
						//Setting Bundle variables
						Bundle tempBundle;
						tempBundle.destinationId = destId;
						tempBundle.sourceId = srcId;
						tempBundle.id = bundId;
						tempBundle.options = BFlags;
						tempBundle.timeStamp = time;
						QByteArray datagramPart;
						datagramPart=datagram.mid(0,lenght);
						tempBundle.data=datagramPart;
						datagram.remove(0,lenght);
						tempBundle.dataLength=lenght;
						datagramPart=datagram.mid(0,srclenght);
						tempBundle.sourceString=datagramPart;
						datagram.remove(0,srclenght);
						datagramPart=datagram.mid(0,dstlenght);
						tempBundle.destinationString=datagramPart;
						datagram.remove(0,dstlenght);
						//Adding variables in the list
						receivedBundles.append(tempBundle);
					}
					emit sendBundleData(receivedBundles);
		break;
		default:	//////log->addLog(0,(QString)"TLV receiving Unknown datagram...");
					//QString name;
					temp = datagram.mid(2,1);
//					function = temp.toushort();
					temp = datagram.mid(32,1);
//					timer = temp.toushort();
					temp = datagram.mid(40,1);
//					nameLenght = temp.toushort();
					temp = datagram.mid(48,0);
					newHello.setFunction(0);
					newHello.setTimer(0);
					newHello.setSenderName(0);

		break;
	}

}


void TLV::receiveHello(Hello hello)
{
	//Setting up variables
	struct HelloHeader header;
	QString nodeName = hello.getSenderName();
	header.type = 0x01;//Hello 
	header.function = (qint32)hello.getFunction();
	header.timer = (qint32)hello.getTimer();
	header.nodeId = (qint32)hello.senderId;
	header.nodeType = (qint32)hello.senderType;
	header.nameLenght = (qint32)nodeName.size();
	//Preparing heder
	QByteArray newDatagram = QByteArray::fromRawData((char *)&header, sizeof(HelloHeader));	
	//Adding Addres Strings
	newDatagram.append(nodeName.toAscii());
	//Sending our TLV datagram
	//////log->addLog(0,(QString)"TLV sending Hello datagram...");
	emit sendDatagram(newDatagram);
}


//Create Dictionary
void TLV::createDictionary(QList<Node> nodeList)
{
	//Setting up variables
	struct DictionaryHeader header;
	header.type = 0xA0;//Dictionary 
	header.flags = 0x00;
	header.lenght = 0x00;
	header.entryCount=(qint32)(nodeList.size());
	header.reserved = 0x00;
	//Preparing heder
	QByteArray newDatagram = QByteArray::fromRawData((char *)&header, sizeof(DictionaryHeader));	
	//Adding Addres Strings
	Node tempNode;
	for (ushort i = 0; i < nodeList.size(); ++i) 
	{
		struct DictionaryNodeHeader newNodeHeader;
		//Resolving data from list
        tempNode = nodeList.at(i);
		newNodeHeader.stringId = (qint32)tempNode.getId();
		newNodeHeader.reserved=0x00;
		newNodeHeader.lenght= (qint32)tempNode.nodeName.size();
		//Puting data to datagram
		QByteArray nodeDatagram = QByteArray::fromRawData((char *)&newNodeHeader, sizeof(newNodeHeader));	
		nodeDatagram.append(tempNode.nodeName);
		newDatagram.append(nodeDatagram);
    }
	//////log->addLog(0,(QString)"TLV Sending dictionary datagram...");
	emit sendDatagram(newDatagram);

}

//Create RIB
void TLV::createRIB(QList<Node> nodeList)
{
	//Setting up variables
	struct DictionaryHeader header; //It is the same as Dictionary
	header.type = 0xA1;//RIB Type
	header.flags = 0x00;
	header.lenght = 0x00;
	header.entryCount=(qint32)nodeList.size();
	header.reserved = 0x00;
	//Preparing heder
	QByteArray newDatagram = QByteArray::fromRawData((char *)&header, sizeof(DictionaryHeader));	
	for (ushort i = 0; i < nodeList.size(); ++i) 
	{
		Node tempNode;
		struct RIBNodeHeader  newNodeHeader;
		//Resolving data from list
        tempNode = nodeList.at(i);
		newNodeHeader.stringId = (qint32)tempNode.getId();
		newNodeHeader.probability = tempNode.getProbability();
		newNodeHeader.RIBFlag = (qint32)tempNode.getFlag();
		//Puting data to datagram
		QByteArray nodeDatagram = QByteArray::fromRawData((char *)&newNodeHeader, sizeof(newNodeHeader));	
		newDatagram.append(nodeDatagram);
    }
	//////log->addLog(0,(QString)"TLV Sending RIB datagram...");
	emit sendDatagram(newDatagram);

}


//Create BundleOffer
void TLV::createBundleOffer(QList<Bundle> bundleList)
{
	//Setting up variables
	struct BundleListHeader header;
	header.type = 0xA2;//Offer
	header.flags = 0x22;
	header.lenght = 0x00;
	header.entryCount=(qint32)bundleList.size();
	header.reserved = 0x00;
	//Preparing heder
	QByteArray newDatagram = QByteArray::fromRawData((char *)&header, sizeof(BundleListHeader));	
	//Adding bundles
	for (ushort i = 0; i < bundleList.size(); ++i) 
	{
		struct BundleListItem newBundleItem;
		//Resolving data from list
        Bundle tempBundle = bundleList.at(i);
		newBundleItem.destinationId=(qint32)tempBundle.destinationId;
		newBundleItem.bundleId=(qint32)tempBundle.id;
		newBundleItem.BFlags=(qint32)tempBundle.options;
		newBundleItem.reserved=0xaa;
		//Puting data to datagram
		QByteArray bundleDatagram = QByteArray::fromRawData((char *)&newBundleItem, sizeof(newBundleItem));	
		newDatagram.append(bundleDatagram);
    }
	//////log->addLog(0,(QString)"TLV Sending bundle offer...");
	emit sendDatagram(newDatagram);

}

//Create BundleRequest
void TLV::createBundleRequest(QList<Bundle> bundleList)
{
	//Setting up variables
	struct BundleListHeader header;
	header.type = 0xA3;//Request
	header.flags = 0x22;
	header.lenght = 0x00;
	header.entryCount=bundleList.size();
	header.reserved = 0x00;
	//Preparing heder
	QByteArray newDatagram = QByteArray::fromRawData((char *)&header, sizeof(BundleListHeader));	
	//Adding bundles
	for (ushort i = 0; i < bundleList.size(); ++i) 
	{
		struct BundleListItem newBundleItem;
		//Resolving data from list
        Bundle tempBundle = bundleList.at(i);
		newBundleItem.destinationId=(qint32)tempBundle.destinationId;
		newBundleItem.bundleId=(qint32)tempBundle.id;
		newBundleItem.BFlags=(qint32)tempBundle.options;
		newBundleItem.reserved=0xaa;
		//Puting data to datagram
		QByteArray bundleDatagram = QByteArray::fromRawData((char *)&newBundleItem, sizeof(BundleListItem));	
		newDatagram.append(bundleDatagram);
    }
	//////log->addLog(0,(QString)"TLV Sending bundle request...");
	emit sendDatagram(newDatagram);

}


///Create Bundle Data
void TLV::createBundleData(QList<Bundle> bundleList)
{

	
	//Setting up variables
	struct BundleListHeader header;
	header.type = 0xA4;//Bundle Data
	header.flags = 0x22;
	header.lenght = 0x00;
	header.entryCount=bundleList.size();
	header.reserved = 0x00;
	//Preparing heder
	QByteArray newDatagram = QByteArray::fromRawData((char *)&header, sizeof(header));	
	//Adding bundles
	for (ushort i = 0; i < bundleList.size(); ++i) 
	{
		struct BundleDataHeader newBundleItem;
		//Resolving data from list
        	Bundle tempBundle = bundleList.at(i);
		newBundleItem.destinationId=(qint32)tempBundle.destinationId;
		newBundleItem.sourceId=(qint32)tempBundle.sourceId;
		newBundleItem.bundleId=(qint32)tempBundle.id;
		newBundleItem.BFlags=(qint32)tempBundle.options;
		newBundleItem.reserved=0xaa;
		newBundleItem.time = tempBundle.timeStamp.toTime_t ();
		//Get bundle data
		QByteArray data;
		data.clear();
		int fileSize;
		if(fileOption==1)
		{
			QString filename;
			filename=QString("%1").arg((int)tempBundle.id);
			QFile file(dir.filePath(filename));
			if(file.exists()==1)
			{
				if (file.open(QIODevice::ReadOnly))
				{
					fileSize=file.size();
					data=file.readAll();
			    		file.close();
				}
			}
		}
		else
		{
			data = tempBundle.data;
		}
		if(data.size()<=0)
			data.clear();
	/*	int size = data.size();
	        QString printout="Size:";
		printout.append(QString("%1").arg((int)size));
		qDebug(printout.toAscii());
		printout.clear();
		printout.append("FileSize:");
		printout.append(QString("%1").arg((int)fileSize));
		qDebug(printout.toAscii());
		printout.clear();
		printout.append("Data:");
		printout.append(data);
		qDebug(printout.toAscii());
	*/	newBundleItem.dataLenght=(qint32)data.size();
		//Get bundle source string
		QByteArray srcData = tempBundle.sourceString;
		newBundleItem.sourceStringLenght=(qint32)srcData.size();
		//Get bundle destination string
		QByteArray dstData = tempBundle.destinationString;
		newBundleItem.destinationStringLenght=(qint32)dstData.size();
		//Puting item header to datagram
		QByteArray bundleDatagram = QByteArray::fromRawData((char *)&newBundleItem, sizeof(newBundleItem));	
		//Puting item data to datagram
		bundleDatagram.append(data);
		bundleDatagram.append(srcData);
		bundleDatagram.append(dstData);
		//Adding it to main datagram
		newDatagram.append(bundleDatagram);

    }
	//////log->addLog(0,(QString)"TLV Sending bundle data...");
	emit sendDatagram(newDatagram);
}


